/*
   Demonstrate a simple example of hidden line removal
*/
#include <windows.h>
#include <math.h>
#include "glut.h"

/* Prototype for the display callback function */
void display( void );

int main(int argc, char** argv)
{
   /* Standard GLUT initialization */
   glutInit(&argc,argv);
   glutInitDisplayMode (GLUT_SINGLE | GLUT_RGB | GLUT_DEPTH);
   glutInitWindowSize(500,500);       /* 500 x 500 pixel window */
   glutInitWindowPosition(100,100);   /* place window near top left of display */
   glutCreateWindow("Hidden lines");  /* window title */
   glutDisplayFunc(display);          /* display callback invoked when window opened */

   /* Initialize OpenGL state */
   /* attributes */
   glClearColor(1.0, 1.0, 1.0, 1.0); /* white background */
   glColor3f(1.0, 0.0, 0.0);         /* draw in red */
   /* set up viewing */
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   glOrtho(-1.0, 1.0, -1.0, 1.0, -1.0, 1.0); /* 3D viewing volume */
   glMatrixMode(GL_MODELVIEW);

   //glEnable(GL_DEPTH_TEST); /* try both with and without this line */

   /* Enter event loop */
   glutMainLoop();

   return 0;  /* we never get here */
}//main()


/* The display() callback function */
void display( void )
{
   glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
   glColor3f(1.0, 0.0, 0.0);
   glBegin(GL_TRIANGLES);          /* this triangle is in the xy-plane */
     glVertex3f(-0.5, 0.0, 0.0 );
     glVertex3f( 0.5, 0.0, 0.0 );
     glVertex3f( 0.0, 0.5, 0.0 );
   glEnd();
   glColor3f(0.0, 0.0, 1.0);
   glBegin(GL_LINES);              /* this line is behind the triangle */
     glVertex3f( 0.5, 0.2, -0.5 ); /* try making the z coord positive */
     glVertex3f(-0.5, 0.2, -0.5 );
   glEnd();
   glFlush();   /* clear buffers */
}//display()
