/*
   This program uses our "fake animation" technique to
   give you a feeling for the orthographic "viewing volume".
*/
#include <windows.h>
#include <math.h>
#include "glut.h"

/* Prototype for the display callback function */
void display( void );

int main(int argc, char** argv)
{
   /* Standard GLUT initialization */
   glutInit(&argc,argv);
   glutInitDisplayMode (GLUT_SINGLE | GLUT_RGB); /* default, not needed */
   glutInitWindowSize(500,500);       /* 500 x 500 pixel window */
   glutInitWindowPosition(100,100);   /* place window near top left of display */
   glutCreateWindow("Orthograpic projection");/* window title */
   glutDisplayFunc(display);          /* display callback invoked when window opened */

   /* Initialize OpenGL state */
   /* attributes */
   glClearColor(1.0, 1.0, 1.0, 1.0); /* white background */
   glColor3f(1.0, 0.0, 0.0);         /* draw in red */
   /* set up viewing */
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   glOrtho(-1.0, 1.0, -1.0, 1.0, -1.0, 1.0); /* 3D viewing volume */
   glMatrixMode(GL_MODELVIEW);

   /* Enter event loop */
   glutMainLoop();

   return 0;  /* we never get here */
}//main()


/* The display() callback function */
void display( void )
{
   float shift = 0.0;
   float delta = 0.1;

   /* The following loop repeatedly clears the screen and draws
   another line segment with each new line segment displaced just
   a little bit from the previous line segment. This creates the
   illusion of movement. The amount of time spent sleeping
   determines the "speed" of this "animation." */
   while(1)
   {
      glClear(GL_COLOR_BUFFER_BIT);    /* clear the window */
      glBegin(GL_LINES);               /* redraw the line */
        glVertex3f( 0.5, 0.0, shift );
        glVertex3f(-0.5, 0.0, shift ); /* moving forward */

        glVertex3f( 0.5, shift, 0.0 ); /* moving up */
        glVertex3f(-0.5, shift, 0.0 );
      glEnd();
      glFlush();   /* clear buffers */
      Sleep(1000); /* 1000 milliseconds */
      shift += delta;
   }

}//display()
